﻿using ConsoleTableExt;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace News
{
    internal class Controller
    {
        private readonly NewsContext _context;

        public Controller(NewsContext feedContext)
        {
            _context = feedContext;
        }

        public void GetNews()
        {
            ConsoleTableBuilder.From(_context.News.Select(x => new { x.NewsId, x.NewsName, x.NewsDate }).ToList())
                .WithTitle("News")
                .ExportAndWriteLine();
        }

        public void GetComments()
        {
            ConsoleTableBuilder.From(_context.Comments.Select(x => new { x.UserId, x.NewsId, x.CommentText }).ToList())
                .WithTitle("Comments")
                .ExportAndWriteLine();
        }

        public void GetAuthors()
        {
            ConsoleTableBuilder.From(_context.Authors.Select(x => new { x.AuthorId, x.AuthorName}).ToList())
                .WithTitle("Authors")
                .ExportAndWriteLine();
        }

        public void GetUsers()
        {
            ConsoleTableBuilder.From(_context.Users.Select(x => new { x.UserId, x.UserName }).ToList())
                .WithTitle("Users")
                .ExportAndWriteLine();
        }

        public void AddUser(User User)
        {
            try
            {
                _context.Users.Add(User);
                _context.SaveChanges();
            }
            catch (Exception e)
            {
                Console.WriteLine(e.InnerException.Message);
            }
        }
    }
}
