﻿using ConsoleTableExt;
using System.Diagnostics;

namespace News
{
    class Program
    {
        public static void Main(string[] args)
        {
            string text;
            using (var sr = new StreamReader("EnterText.txt"))
            {
                text = sr.ReadToEnd();
            }

            using var context = new NewsContext();
            Controller controller = new(context);
            string operation = "";
            do
            {
                Console.WriteLine(text);
                operation = Console.ReadLine() ?? "";
                switch (operation)
                {
                    case "0":
                        break;
                    case "1":
                        controller.GetNews();
                        break;
                    case "2":
                        controller.GetComments();
                        break;
                    case "3":
                        controller.GetAuthors();
                        break;
                    case "4":
                        controller.GetUsers();
                        break;
                    case "5":
                        Console.WriteLine("Введите Имя");
                        User user = new()
                        {
                            UserName = Console.ReadLine(),
                        };
                        controller.AddUser(user);
                        break;
                    case "6":
                        Test(controller, context);
                        break;
                    default:
                        Console.WriteLine("Такой операции нет");
                        break;
                }
            } while (operation != "0");
        }
        public static void Test(Controller controller, NewsContext context)
        {



            var result = new[]
            {
                new { Name = "1", timems = MeasureTime(controller.GetNews)},
                new { Name = "2", timems = MeasureTime(controller.GetComments)},
                new { Name = "3", timems = MeasureTime(controller.GetAuthors)},
                new { Name = "4", timems = MeasureTime(() => controller.GetUsers())},
                new { Name = "5", timems = MeasureTime(() => 
                {
                    Random r = new Random();
                    string name = "";
                    for (int i = 0; i < 7; i++)
                        name += (char)r.Next(65, 89);
                    User user = new() { 
                        UserName = name[..7], 
                    }; 
                    controller.AddUser(user); 
                })},
            }.ToList();
            ConsoleTableBuilder.From(result).ExportAndWriteLine();
        }

        public static double MeasureTime(Action action, int count = 10)
        {
            long sumTime = 0;
            Stopwatch stopwatch = new();
            for (int i = 0; i < count; i++)
            {
                stopwatch.Start();
                action.Invoke();
                stopwatch.Stop();
                sumTime += stopwatch.ElapsedMilliseconds;
            }
            return sumTime / count;
        }
    }
}
